
#include <Adafruit_NeoPixel.h>
#include "LEDS_64_panel_color_a.h"
#include <PinChangeInt.h>


Adafruit_NeoPixel LEDS = Adafruit_NeoPixel(PIXEL_NUM, LED_PIN, NEO_GRBW + NEO_KHZ800);

uint8_t CharGroup = 0;
volatile bool State = false;


void setup()
{
  pinMode(KEY_PIN, INPUT);
  digitalWrite(KEY_PIN, HIGH);
  PCintPort::attachInterrupt(KEY_PIN, &Key_ISR, FALLING);
  
  LEDS.begin();
  LEDS.show();
}
//----------------------------------------
void loop()
{
  switch(CharGroup)
  {
    case 0:
      Group_1();
    break;

    case 1:
      Group_2();
    break;

    default:
    break;
  }
}
//----------------------------------------
void Group_1()
{
  const uint8_t PIC_NUM = 23;

  const uint32_t *DIGITS[PIC_NUM] = { Picture_4, Picture_5, Picture_6, Picture_7, Picture_8, Picture_9, Picture_10, Picture_11, Picture_12, Picture_13, Picture_14, Picture_15, Picture_16, Picture_17, Picture_18, Picture_19, Picture_20, Picture_21, Picture_22, Picture_23, Picture_24, Picture_25, Picture_26, };
  static uint8_t CurDig = 0;
  
  ChangeCharColor(DIGITS[CurDig]);
  LEDS.show();
  delay(SHOW_DELAY);

  CurDig++;
  if (CurDig == PIC_NUM)
  {
    CurDig = 0;
    delay(LAST_PIC_DELAY);
  }

  if (State)
  {
    CharGroup++;
    if (CharGroup == CharGroups)
      CharGroup = 0;

    CurDig = 0;
    State = false;

    PCintPort::detachInterrupt(KEY_PIN);
    delay(300);
    PCintPort::attachInterrupt(KEY_PIN, &Key_ISR, FALLING);
  }
}
//----------------------------------------
void Group_2()
{
  const uint8_t PIC_NUM = 3;

  const uint32_t *DIGITS[PIC_NUM] = { Picture_1,  Picture_2, Picture_3, };
  static uint8_t CurDig = 0;
  
  ChangeCharColor(DIGITS[CurDig]);
  LEDS.show();
  delay(SHOW_DELAY);

  CurDig++;
  if (CurDig == PIC_NUM)
  {
    CurDig = 0;
    delay(LAST_PIC_DELAY);
  }

  if (State)
  {
    CharGroup++;
    if (CharGroup == CharGroups)
      CharGroup = 0;

    CurDig = 0;
    State = false;

    PCintPort::detachInterrupt(KEY_PIN);
    delay(300);
    PCintPort::attachInterrupt(KEY_PIN, &Key_ISR, FALLING);
  }
}
//----------------------------------------
void ChangeCharColor(const uint32_t *CharPixel)
{
  for (uint8_t i = 0; i < STICK_NUM; i++)
  {
    uint8_t StartIndex = i * PIXEL_IN_STICK;

    for (uint8_t j = StartIndex; j < (StartIndex + PIXEL_IN_STICK); j++)
    {
      uint8_t PixelAdr;

      if ((i % 2) == 0)
        PixelAdr = j;
      else
      {
        PixelAdr = StartIndex * 2 + 7 - j;
      }
            
      LEDS.setPixelColor(j, pgm_read_dword(&CharPixel[PixelAdr]));
    }
  }
}
//----------------------------------------
void Key_ISR()
{
  State = true;
}



